package br.usp.nds.remote.integracao;

import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.persistence.EntityManager;

import br.usp.nds.remote.persistencia.Evento;
import br.usp.nds.remote.persistencia.GeracaoEvento;
import br.usp.nds.remote.persistencia.GeracaoTicket;
import br.usp.nds.remote.persistencia.Persistencia;
import br.usp.nds.remote.persistencia.Status;
import br.usp.nds.remote.persistencia.Ticket;

public class GeradorTickets {

	private Map<Integer, GeracaoTicket> geradores = new HashMap();
	private static GeradorTickets instance;
	
	public void processarEvento(GeracaoEvento ge, Evento e) {
		Collection<GeracaoTicket> gts = geradores.values();
		for (GeracaoTicket gt : gts) {
			System.out.println(gt.getGeracaoEvento().getCodigo() + " " + ge.getCodigo());
			if (gt.getGeracaoEvento().getCodigo() == ge.getCodigo()) {
				EntityManager em = Persistencia.getInstance().getEMF().createEntityManager();
				em.getTransaction().begin();
				Ticket ticket = new Ticket();
				ticket.setCriacao(new Date());
				ticket.setDecricao(gt.getDescricao());
				ticket.setPrioridade(gt.getPrioridade());
				ticket.setStatus(Status.ABERTO);
				ticket.setEvento(e);
				ticket.setSubsistema(e.getSensor().getSubsistema());
				ticket.setEmbarcacao(e.getSensor().getEmbarcacao());
				em.persist(ticket);
				em.getTransaction().commit();
				em.close();
			}
		}
	}
	
	public void registrarInsercao(GeracaoTicket gerador) {
		geradores.put(gerador.getCodigo(), gerador);
	}
	
	public void registrarAlteracao(GeracaoTicket gerador) {
		geradores.put(gerador.getCodigo(), gerador);
	}
	
	public void registrarExclusao(GeracaoTicket gerador) {
		geradores.remove(gerador.getCodigo());
	}
	
	public void carregar() {
		geradores.clear();
		EntityManager em = Persistencia.getInstance().getEMF().createEntityManager();
		List<GeracaoTicket> gts = em.createQuery("SELECT g FROM GeracaoTicket g").getResultList();
		for (GeracaoTicket gt : gts) {
			geradores.put(gt.getCodigo(), gt);
			gt.getGeracaoEvento().getCodigo();
		}
		em.close();
	}
	
	public static GeradorTickets getInstance() {
		if (instance == null) {
			instance = new GeradorTickets();
		}
		return instance;
	}
	
	private GeradorTickets() {
	}
}
