package br.usp.nds.remote.persistencia;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Transient;

@Entity
public class Auditoria extends Entidade implements Serializable	 {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int codigo;
	private Date data;
	private String usuario;
	private String entidade;
	private String operacao;
	@Column(length = 4000)
	private String params;
	@Transient
	private String inicio;
	@Transient
	private String fim;
	
	public Auditoria() {
	}
	
	public Auditoria(Date data, String usuario, String entidade, String operacao, String params) {
		super();
		this.data = data;
		this.usuario = usuario;
		this.entidade = entidade;
		this.operacao = operacao;
		this.params = params;
	}

	public List<String> listarUsuario() {
		return em.createQuery("SELECT DISTINCT usuario FROM Auditoria ORDER BY usuario").getResultList();
	}

	public List<String> listarEntidade() {
		return em.createQuery("SELECT DISTINCT entidade FROM Auditoria ORDER BY entidade").getResultList();
	}
	
	public List<String> listarOperacao() {
		return em.createQuery("SELECT DISTINCT operacao FROM Auditoria WHERE entidade = '" + entidade + "' ORDER BY operacao").getResultList();
	}	
	
	public List<Auditoria> listar() {
		String query = "SELECT a FROM Auditoria a WHERE 1 = 1";
		if (inicio != null && !inicio.isEmpty()) {
			query += " AND YEAR(data) * 10000 + MONTH(data) * 100 + DAY(data) >= " + inicio.substring(6) + inicio.substring(3, 5) + inicio.substring(0, 2);
		}
		if (fim != null && !fim.isEmpty()) {
			query += " AND YEAR(data) * 10000 + MONTH(data) * 100 + DAY(data) <= " + fim.substring(6) + fim.substring(3, 5) + fim.substring(0, 2);
		}
		if (usuario != null && !usuario.isEmpty()) {
			query += " AND usuario = '" + usuario + "'";
		}
		if (entidade != null && !entidade.isEmpty()) {
			query += " AND entidade = '" + entidade + "'";
		}
		if (operacao != null && !operacao.isEmpty()) {
			query += " AND operacao = '" + operacao + "'";
		}
		query += " ORDER BY a.codigo DESC";
		return em.createQuery(query).getResultList();
	}
	
	public static void gravar(EntityManager em, String usuario, String entidade, String operacao, String params) {
		em.persist(new Auditoria(new Date(), usuario, entidade, operacao, params));
	}
	
	public String getInicio() {
		return inicio;
	}
	public void setInicio(String inicio) {
		this.inicio = inicio;
	}
	public String getFim() {
		return fim;
	}

	public void setFim(String fim) {
		this.fim = fim;
	}

	public int getCodigo() {
		return codigo;
	}
	public void setCodigo(int codigo) {
		this.codigo = codigo;
	}
	public Date getData() {
		return data;
	}
	public void setData(Date data) {
		this.data = data;
	}
	public String getUsuario() {
		return usuario;
	}
	public void setUsuario(String usuario) {
		this.usuario = usuario;
	}

	public String getEntidade() {
		return entidade;
	}

	public void setEntidade(String entidade) {
		this.entidade = entidade;
	}

	public String getOperacao() {
		return operacao;
	}

	public void setOperacao(String operacao) {
		this.operacao = operacao;
	}

	public String getParams() {
		return params;
	}

	public void setParams(String params) {
		this.params = params;
	}
}
