package br.usp.nds.remote.persistencia;

import java.io.Serializable;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

@Entity
public class Subsistema extends Entidade implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int codigo;
	private String nome;
	
	public List<Subsistema> listar() {
		return em.createQuery("SELECT s FROM Subsistema s ORDER BY s.nome").getResultList();
	}
	
	public void incluir() {
		em.persist(this);
	}
	
	public void alterar() {
		em.merge(this);
	}
	
	public void excluir() {
		em.remove(em.find(Subsistema.class, codigo));
	}
	
	public int getCodigo() {
		return codigo;
	}
	public void setCodigo(int codigo) {
		this.codigo = codigo;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
}
